
-- by Schnulla-817


Window = {};

function Window.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Window:load(xmlFile)

	local rotationPartNodewindow = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.window#index"));
    if rotationPartNodewindow ~= nil then
        self.rotationPartwindow = {};
        self.rotationPartwindow.node = rotationPartNodewindow;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartwindow#minRot"));
        self.rotationPartwindow.minRot = {};
        self.rotationPartwindow.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwindow.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwindow.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.window#maxRot"));
        self.rotationPartwindow.maxRot = {};
        self.rotationPartwindow.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwindow.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwindow.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwindow.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.window#rotTime"), 2)*1000;
        self.rotationPartwindow.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.window#touchRotLimit"), 10));
    end;

end;

function Window:keyEvent(unicode, sym, modifier, isDown)
end;

function Window:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Window:update(dt)

	if InputBinding.hasEvent(InputBinding.WINDOW) then
		self.rotationMaxwindow = not self.rotationMaxwindow;
	end;

    if self.isEntered then
	    if self.rotationPartwindow ~= nil then
		   local x, y, z = getRotation(self.rotationPartwindow.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwindow.maxRot, self.rotationPartwindow.minRot, 3, self.rotationPartwindow.rotTime, dt, not self.rotationMaxwindow);
		   setRotation(self.rotationPartwindow.node, unpack(newRot));
        end;
	end;

end;

function Window:draw()
g_currentMission:addHelpButtonText(g_i18n:getText("WINDOW"), InputBinding.WINDOW);
end;

function Window:onEnter()
end;

function Window:onLeave()
end;

function Window:delete()
end;